'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _button = require('./button');

var _button2 = _interopRequireDefault(_button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Editor = function (_React$Component) {
  _inherits(Editor, _React$Component);

  function Editor(props) {
    _classCallCheck(this, Editor);

    var _this = _possibleConstructorReturn(this, (Editor.__proto__ || Object.getPrototypeOf(Editor)).call(this, props));

    _this.captureKeys = _this.captureKeys.bind(_this);
    _this.wrapSelection = _this.wrapSelection.bind(_this);
    _this.wrapSelectedLines = _this.wrapSelectedLines.bind(_this);
    _this.setSelection = _this.setSelection.bind(_this);
    _this.getSelection = _this.getSelection.bind(_this);
    return _this;
  }

  _createClass(Editor, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.editor = $("#editor")[0];
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      document.addEventListener("keydown", this.captureKeys);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener("keydown", this.captureKeys);
    }
  }, {
    key: 'setSelection',
    value: function setSelection(start, end) {
      this.editor.selectionStart = start;
      this.editor.selectionEnd = end;
    }
  }, {
    key: 'getSelection',
    value: function getSelection() {
      return [this.editor.selectionStart, this.editor.selectionEnd].sort(function (a, b) {
        return a > b;
      });
    }
  }, {
    key: 'selectLines',
    value: function selectLines() {
      var lines = this.readSelectedLines();
      var start = lines.previousLines.reduce(function (m, l) {
        return m += l.length + 1;
      }, 0);
      var end = lines.selectedLines.reduce(function (m, l) {
        return m += l.length + 1;
      }, start);
      this.setSelection(start, end);
    }
  }, {
    key: 'wrapSelection',
    value: function wrapSelection(before, after) {
      var _getSelection = this.getSelection(),
          _getSelection2 = _slicedToArray(_getSelection, 2),
          start = _getSelection2[0],
          end = _getSelection2[1];

      var selected = this.editor.value.substring(start, end);
      var newBody = this.editor.value.substring(0, start) + before + selected + after + this.editor.value.substring(end);
      this.props.onChange(newBody);
      this.editor.value = newBody;
      this.editor.focus();
      this.setSelection(start + before.length, end + before.length);
    }
  }, {
    key: 'readSelectedLines',
    value: function readSelectedLines() {
      var _getSelection3 = this.getSelection(),
          _getSelection4 = _slicedToArray(_getSelection3, 2),
          start = _getSelection4[0],
          end = _getSelection4[1];

      var count = 0,
          remaining = start;
      var previousLines = [],
          selectedLines = [],
          nextLines = [];
      var lines = this.editor.value.split("\n").map(function (l) {
        remaining -= l.length + 1;

        if (remaining >= 0) {
          previousLines.push(l);
        } else if (count > end) {
          nextLines.push(l);
        } else {
          selectedLines.push(l);
        }

        count += l.length + 1;
        return l;
      });

      return { start: start, end: end, selected: this.editor.value.substring(start, end), previousLines: previousLines, nextLines: nextLines, selectedLines: selectedLines, lines: lines };
    }
  }, {
    key: 'wrapSelectedLines',
    value: function wrapSelectedLines(before, after) {
      var lines = this.readSelectedLines();
      var selectedLines = lines.selectedLines.map(function (l) {
        return before + l + after + "\n";
      }).join('');

      var _getSelection5 = this.getSelection(),
          _getSelection6 = _slicedToArray(_getSelection5, 2),
          start = _getSelection6[0],
          end = _getSelection6[1];

      var newBody = lines.previousLines.map(function (l) {
        return l + "\n";
      }).join('') + selectedLines + lines.nextLines.join("\n");
      this.props.onChange(newBody);
      this.editor.value = newBody;
      this.editor.focus();
      this.setSelection(start + before.length, end + before.length + (before.length + after.length) * (lines.selectedLines.length - 1));
    }
  }, {
    key: 'captureKeys',
    value: function captureKeys(event) {
      switch (event.key) {
        case "Tab":
          this.wrapSelectedLines("  ", "");
          event.preventDefault();
          break;

        case "Enter":
          if (this.readSelectedLines().selected.length == 0) {
            var indent = this.readSelectedLines().selectedLines[0].match(/^ +/) || "";
            this.wrapSelection("\n" + indent, "");
            event.preventDefault();
            break;
          }

        case "s":
        case "S":
          if (event.ctrlKey) {
            this.props.changed ? this.props.onSave() : null;
            event.preventDefault();
            break;
          }

        case "l":
        case "L":
          if (event.ctrlKey) {
            this.selectLines();
            event.preventDefault();
            break;
          }

        case "x":
        case "X":
          if (event.ctrlKey) {
            var lines = this.readSelectedLines();
            if (lines.selected.length == 0) {
              this.selectLines();
            }
            break;
          }
      }
    }
  }, {
    key: 'renderButton',
    value: function renderButton(label, alt, before, after, wrapSelectedLines) {
      return _react2.default.createElement(_button2.default, { wrapMethod: wrapSelectedLines ? this.wrapSelectedLines : this.wrapSelection, editor: this.editor, label: label, alt: alt, before: before, after: after });
    }
  }, {
    key: 'render',
    value: function render() {
      var separator = _react2.default.createElement('span', { style: s.wide(5) });

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { style: s.flex },
          this.renderButton('bold', 'Negrito', '*', '*'),
          this.renderButton('underline', 'Sublinhado', '_', '_'),
          this.renderButton('italic', 'Itálico', '/', '/'),
          separator,
          this.renderButton('picture-o', 'Imagem', '[image:', ']'),
          this.renderButton('link', 'URL', '[url:', ']'),
          this.renderButton('youtube', 'YouTube', '[youtube:', ']'),
          this.renderButton('header', 'Título (permite múltiplos "#")', '#', ''),
          separator,
          this.renderButton('expand', 'Margem (espaçamento externo)', '<margin:10:', ':margin>'),
          this.renderButton('compress', 'Padding (espaçamento interno)', '<padding:10:', ':padding>'),
          separator,
          this.renderButton('font', 'Cor da fonte', '<color:red:', ':color>'),
          this.renderButton('tint', 'Cor de fundo', '<bg:red:', ':bg>'),
          separator,
          this.renderButton('align-left', 'Alinhar à esquerda', '<l:\n', '\n:l>'),
          this.renderButton('align-right', 'Alinhar à direita', '<r:\n', '\n:r>'),
          this.renderButton('align-justify', 'Justificar', '<j:\n', '\n:j>'),
          this.renderButton('align-center', 'Alinhar ao centro', '<c:\n', '\n:c>'),
          this.renderButton('indent', 'Indentar', '  ', '', true)
        ),
        _react2.default.createElement('textarea', { id: 'editor', onChange: this.props.onChange, value: this.props.body, style: [s.wide("calc(100% - 6px)"), s.high(300), s.margin(10, 0), { resize: "vertical" }].merge() })
      );
    }
  }]);

  return Editor;
}(_react2.default.Component);

exports.default = Editor;