'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactYoutube = require('react-youtube');

var _reactYoutube2 = _interopRequireDefault(_reactYoutube);

var _reactQuickStyles = require('react-quick-styles');

var _reactQuickStyles2 = _interopRequireDefault(_reactQuickStyles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Elements = function (_React$Component) {
  _inherits(Elements, _React$Component);

  function Elements(props) {
    _classCallCheck(this, Elements);

    var _this = _possibleConstructorReturn(this, (Elements.__proto__ || Object.getPrototypeOf(Elements)).call(this, props));

    _this.state = {};
    return _this;
  }

  _createClass(Elements, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.videos = {};
    }
  }, {
    key: 'renderByClassName',
    value: function renderByClassName(fragment) {
      fragment = fragment || this.props.fragment;
      var _props = this.props,
          renderString = _props.renderString,
          compileFragment = _props.compileFragment,
          i = _props.i;

      var className = fragment.constructor.name;

      switch (className) {
        case 'String':
          return _react2.default.createElement(
            'span',
            { key: i, className: 'string', style: [].merge() },
            fragment
          );
        case 'Array':
          return fragment.length == 1 ? this.render(fragment[0]) : _react2.default.createElement(
            'span',
            { key: i, className: 'array', style: [_reactQuickStyles2.default.high()].merge() },
            fragment.map(function (item, i) {
              return compileFragment(item, i);
            })
          );
        default:
          return null;
      }
    }
  }, {
    key: 'renderByRuleName',
    value: function renderByRuleName(fragment) {
      var _this2 = this;

      fragment = fragment || this.props.fragment;
      var _props2 = this.props,
          renderString = _props2.renderString,
          compileFragment = _props2.compileFragment,
          i = _props2.i;


      switch (fragment.rule) {
        case 'literal':
        case 'escape-char':
          return _react2.default.createElement(
            'span',
            { key: i, className: fragment.rule },
            fragment.content
          );
        case 'columns':
          return _react2.default.createElement(
            'div',
            { key: i, className: 'columns', style: [_reactQuickStyles2.default.flex, _reactQuickStyles2.default.wrap].merge() },
            fragment.content.map(function (item, i) {
              return compileFragment(item, i);
            })
          );
        case 'column':
          return _react2.default.createElement(
            'div',
            { key: i, className: 'column', style: [_reactQuickStyles2.default.wide(100 * fragment.content[1] / 12 + "%"), _reactQuickStyles2.default.minWidth(fragment.content[1] * 30), _reactQuickStyles2.default.shrink(0)].merge() },
            _react2.default.createElement(
              'div',
              { style: _reactQuickStyles2.default.padding(5) },
              renderString(fragment.content[2])
            )
          );
        case 'image':
          var style = fragment.content[2] ? [_reactQuickStyles2.default.maxWidth(), _reactQuickStyles2.default.padding(10), { float: fragment.content[2] }] : [_reactQuickStyles2.default.wide()];
          return _react2.default.createElement(
            'a',
            { href: fragment.content[5] },
            _react2.default.createElement('img', { key: i, className: 'image', style: style.merge(), src: fragment.content[3] })
          );
        case 'youtube':
          var videoSeed = fragment.content + i;
          if (!this.state[videoSeed]) this.state[videoSeed] = { width: "100%", height: "0" };
          this.videos[videoSeed] = this.videos[videoSeed] || _react2.default.createElement(_reactYoutube2.default, { id: videoSeed, videoId: fragment.content, opts: this.state[videoSeed], onReady: function onReady() {
              return _this2.updateVideoDimensions(videoSeed);
            } });
          return this.videos[videoSeed];
        case 'left':
        case 'center':
        case 'right':
        case 'justify':
          return _react2.default.createElement(
            'div',
            { key: i, className: 'alignment', style: { textAlign: fragment.rule } },
            renderString(fragment.content[2])
          );
        case 'margin':
        case 'padding':
          return _react2.default.createElement(
            'div',
            { key: i, className: fragment.rule, style: _reactQuickStyles2.default[fragment.rule](fragment.content[1].split(',')) },
            renderString(fragment.content[2])
          );
        case 'heading':
          return _react2.default.createElement("h" + fragment.content[1].length, { key: i, className: 'heading', style: [_reactQuickStyles2.default.padding(10)].merge() }, fragment.content[2]);
        case 'url':
          var url = fragment.content;
          return _react2.default.createElement(
            'a',
            { key: i, className: 'url', style: [_reactQuickStyles2.default.wrapWord].merge(), href: url[3] },
            url[2] || url[3]
          );
        case 'color':
          return _react2.default.createElement(
            'div',
            { key: i, className: 'color', style: { color: fragment.content[1] } },
            renderString(fragment.content[2])
          );
        case 'bg':
          return _react2.default.createElement(
            'div',
            { key: i, className: 'bg', style: [_reactQuickStyles2.default.inline, _reactQuickStyles2.default.rect(), { backgroundColor: fragment.content[1] }].merge() },
            renderString(fragment.content[2])
          );
        case 'new-line':
          return _react2.default.createElement('br', { className: 'new-line', key: i });
        default:
          null;
      }
    }
  }, {
    key: 'updateVideoDimensions',
    value: function updateVideoDimensions(videoSeed) {
      var obj = {};
      var e = $('#' + videoSeed);
      obj[videoSeed] = { width: e.width(), height: e.width() * 315 / 560 };
      if (this.state[videoSeed] != obj) {
        this.videos[videoSeed] = null;
        this.setState(obj);
      }
    }
  }, {
    key: 'renderObject',
    value: function renderObject(fragment) {
      fragment = fragment || this.props.fragment;
      var _props3 = this.props,
          renderString = _props3.renderString,
          compileFragment = _props3.compileFragment,
          i = _props3.i;

      var className = fragment.constructor.name;

      if (className == 'Object') {
        return _react2.default.createElement(
          'span',
          { key: i, className: fragment.rule, style: _reactQuickStyles2.default[fragment.rule] },
          compileFragment(fragment.content)
        );
      } else {
        console.error('ERROR!!!: UNKNOWN FRAGMENT: ' + JSON.stringify(fragment));
        return null;
      }
    }
  }, {
    key: 'render',
    value: function render(fragment) {
      if (this.props.fragment.match && this.props.fragment.match(/^\s*$/)) {
        return null;
      } else {
        return this.props.customElementsRenderer(fragment || this.props.fragment, this.props) || this.renderByClassName(fragment) || this.renderByRuleName(fragment) || this.renderObject(fragment);
      }
    }
  }]);

  return Elements;
}(_react2.default.Component);

exports.default = Elements;