'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _elements = require('./elements');

var _elements2 = _interopRequireDefault(_elements);

var _rules = require('./rules');

var _rules2 = _interopRequireDefault(_rules);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Markdown = function (_React$Component) {
  _inherits(Markdown, _React$Component);

  function Markdown(props) {
    _classCallCheck(this, Markdown);

    var _this = _possibleConstructorReturn(this, (Markdown.__proto__ || Object.getPrototypeOf(Markdown)).call(this, props));

    _this.i = 0;
    _this.renderString = _this.renderString.bind(_this);
    _this.compileFragment = _this.compileFragment.bind(_this);
    _this.rules = (_this.props.customRules || []).concat(_rules2.default);
    _this.customElementsRenderer = _this.props.customElementsRenderer || function () {};
    return _this;
  }

  _createClass(Markdown, [{
    key: 'fragmentString',
    value: function fragmentString(str) {
      var rule = this.firstMatchedRule(str);
      if (rule) {
        var index = str.search(rule.regexp);
        var length = str.match(rule.regexp)[0].length;
        var before = str.slice(0, index);
        var matched = str.match(rule.regexp);
        var fragmentedMatched = rule.stopRulesPropagation ? matched[1] : this.fragmentString(matched[rule.i || 1]);
        var result = [this.fragmentString(before), { content: rule.multiMatch ? matched : fragmentedMatched, rule: rule.name, type: rule.type }];

        var after = str.slice(index + length);
        var fragmentedAfter = this.fragmentString(after);
        result = fragmentedAfter.constructor.name == "Array" ? [].concat(_toConsumableArray(result), _toConsumableArray(fragmentedAfter)) : [].concat(_toConsumableArray(result), [fragmentedAfter]);

        return result.compact().flatten();
      } else {
        return str;
      }
    }
  }, {
    key: 'firstMatchedRule',
    value: function firstMatchedRule(str) {
      var sortedRules = this.rules.map(function (rule) {
        return [str.search(rule.regexp), rule];
      }).sort(function (a, b) {
        return a[0] - b[0];
      });
      var filteredRules = sortedRules.filter(function (rule) {
        return rule[0] >= 0;
      }).map(function (rule) {
        return rule[1];
      });
      return filteredRules[0];
    }
  }, {
    key: 'compileFragment',
    value: function compileFragment(fragment) {
      if (fragment) {
        this.i += 1;
        return _react2.default.createElement(_elements2.default, { key: this.i, fragment: fragment, renderString: this.renderString, compileFragment: this.compileFragment, i: this.i, customElementsRenderer: this.customElementsRenderer });
      } else {
        return null;
      }
    }
  }, {
    key: 'renderString',
    value: function renderString(str) {
      return this.compileFragment(this.fragmentString(str));
    }
  }, {
    key: 'render',
    value: function render() {
      return this.renderString(this.props.children, 1);
    }
  }]);

  return Markdown;
}(_react2.default.Component);

exports.default = Markdown;